%global momorel 4.1
%global src_version 2.02~beta2

# Modules always contain just 32-bit code
%define _libdir %{_exec_prefix}/lib

# 64bit intel machines use 32bit boot loader
# (We cannot just redefine _target_cpu, as we'd get i386.rpm packages then)
#%%ifarch x86_64
#%%define _target_platform x86_64-%{_vendor}-%{_target_os}%{?_gnu}
#%%endif
#sparc is always compile 64 bit
%ifarch %{sparc}
%define _target_platform sparc64-%{_vendor}-%{_target_os}%{?_gnu}
%endif

%ifarch %{ix86}
%global grubefiarch i386-efi
%global grubefiname grubia32.efi
%global grubeficdname gcdia32.efi
%endif
%ifarch x86_64
%global grubefiarch %{_arch}-efi
%global grubefiname grubx64.efi
%global grubeficdname gcdx64.efi
%endif
%ifarch aarch64
%global grubefiarch arm64-efi
%global grubefiname grubaa64.efi
%endif

%if ! 0%{?efi}
%global efi %{ix86} x86_64 ia64
%endif

%global efidir redhat

Name:           grub2
Version:        2.02
Release:        0.%{momorel}m%{?dist}
Summary:        Bootloader with support for Linux, Multiboot and more

Group:          System Environment/Base
License:        GPLv3+
URL:            http://www.gnu.org/software/grub/
Obsoletes:	grub < 0.98
#Source0:        ftp://ftp.gnu.org/gnu/grub/grub-%{src_version}.tar.xz
Source0:        ftp://alpha.gnu.org/gnu/grub/grub-%{src_version}.tar.xz
NoSource:	0
Source1:        90_persistent
Source2:        grub.default
Source3:		README.Fedora
Source4:		http://unifoundry.com/unifont-5.1.20080820.pcf.gz
NoSource:	4
Source5:		theme.tar.bz2
Patch0001: 0001-fix-EFI-detection-on-Windows.patch
Patch0002: 0002-grub-core-kern-arm-cache_armv6.S-Remove-.arch-direct.patch
Patch0003: 0003-INSTALL-Cross-compiling-the-GRUB-Fix-some-spelling-m.patch
Patch0004: 0004-NEWS-First-draft-of-2.02-entry.patch
Patch0005: 0005-Merge-branch-master-of-git.sv.gnu.org-srv-git-grub.patch
Patch0006: 0006-NEWS-The-cmosclean-command-in-fact-dates-back-to-1.9.patch
Patch0007: 0007-remove-unused-error.h-from-kern-emu-misc.c.patch
Patch0008: 0008-Don-t-abort-on-unavailable-coreboot-tables-if-not-ru.patch
Patch0009: 0009-NEWS-Add-few-missing-entries.-Correct-existing-ones.patch
Patch0010: 0010-strip-.eh_frame-section-from-arm64-efi-kernel.patch
Patch0011: 0011-use-grub-boot-aa64.efi-for-boot-images-on-AArch64.patch
Patch0012: 0012-fix-32-bit-compilation-on-MinGW-w64.patch
Patch0013: 0013-Change-grub-mkrescue-to-use-bootaa64.efi-too.patch
Patch0014: 0014-arm64-set-correct-length-of-device-path-end-entry.patch
Patch0015: 0015-Makefile.util.def-grub-macbless-Change-mansection-to.patch
Patch0016: 0016-add-part_apple-to-EFI-rescue-image-to-fix-missing-pr.patch
Patch0017: 0017-freebsd-hostdisk.c-is-only-ever-compiled-on-FreeBSD.patch
Patch0018: 0018-Prefer-more-portable-test-1-constructs.patch
Patch0019: 0019-NEWS-Add-few-missing-entries.patch
Patch0020: 0020-grub-core-kern-efi-efi.c-Ensure-that-the-result-star.patch
Patch0021: 0021-util-grub-mount.c-Extend-GCC-warning-workaround-to-g.patch
Patch0022: 0022-reintroduce-BUILD_LDFLAGS-for-the-cross-compile-case.patch
Patch0023: 0023-grub-core-term-terminfo.c-Recognize-keys-F1-F12.patch
Patch0024: 0024-Fix-ChangeLog-date.patch
Patch0025: 0025-Use-_W64-to-detect-MinGW-W64-32-instead-of-_FILE_OFF.patch
Patch0026: 0026-add-BUILD_EXEEXT-support-to-fix-make-clean-on-Window.patch
Patch0027: 0027-fix-include-loop-on-MinGW-due-to-libintl.h-pulling-s.patch
Patch0028: 0028-grub-core-commands-macbless.c-Rename-FILE-and-DIR-to.patch
Patch0029: 0029-Makefile.util.def-Link-grub-ofpathname-with-zfs-libs.patch
Patch0030: 0030-Makefile.am-default_payload.elf-Add-modules.patch
Patch0031: 0031-fix-removal-of-cpu-machine-links-on-mingw-msys.patch
Patch0032: 0032-grub-core-normal-main.c-read_config_file-Buffer-conf.patch
Patch0033: 0033-util-grub-install.c-Fix-a-typo.patch
Patch0034: 0034-use-MODULE_FILES-for-genemuinit-instead-of-MOD_FILES.patch
Patch0035: 0035-Ignore-EPERM-when-modifying-kern.geom.debugflags.patch
Patch0036: 0036-change-stop-condition-to-avoid-infinite-loops.patch
Patch0037: 0037-increase-network-try-interval-gradually.patch
Patch0038: 0038-look-for-DejaVu-also-in-usr-share-fonts-truetype.patch
Patch0039: 0039-Show-detected-path-to-DejaVuSans-in-configure-summar.patch
Patch0040: 0040-add-GRUB_WINDOWS_EXTRA_DIST-to-allow-shipping-runtim.patch
Patch0041: 0041-util-grub-install.c-write_to_disk-Add-an-info-messag.patch
Patch0042: 0042-util-grub-install.c-List-available-targets.patch
Patch0043: 0043-Fix-several-translatable-strings.patch
Patch0044: 0044-do-not-set-default-prefix-in-grub-mkimage.patch
Patch0045: 0045-fix-Mingw-W64-32-cross-compile-failure-due-to-printf.patch
Patch0046: 0046-grub-core-term-serial.c-grub_serial_register-Fix-inv.patch
Patch0047: 0047-grub-install-support-for-partitioned-partx-loop-devi.patch
Patch0048: 0048-grub-core-term-at_keyboard.c-Tolerate-missing-keyboa.patch
Patch0049: 0049-.gitignore-add-missing-files-and-.exe-variants.patch
Patch0050: 0050-util-grub-mkfont.c-Downgrade-warnings-about-unhandle.patch
Patch0051: 0051-grub-core-disk-ahci.c-Do-not-enable-I-O-decoding-and.patch
Patch0052: 0052-grub-core-disk-ahci.c-Allocate-and-clean-space-for-a.patch
Patch0053: 0053-grub-core-disk-ahci.c-Add-safety-cleanups.patch
Patch0054: 0054-grub-core-disk-ahci.c-Properly-handle-transactions-w.patch
Patch0055: 0055-grub-core-disk-ahci.c-Increase-timeout.-Some-SSDs-ta.patch
Patch0056: 0056-util-grub-mkfont.c-Build-fix-for-argp.h-with-older-g.patch
Patch0057: 0057-util-grub-mkrescue.c-Build-fix-for-argp.h-with-older.patch
Patch0058: 0058-add-grub_env_set_net_property-function.patch
Patch0059: 0059-add-bootpath-parser-for-open-firmware.patch
Patch0060: 0060-grub-core-disk-ahci.c-Ignore-NPORTS-field-and-rely-o.patch
Patch0061: 0061-grub-core-kern-i386-coreboot-mmap.c-Filter-out-0xa00.patch
Patch0062: 0062-grub-core-loader-i386-multiboot_mbi.c-grub_multiboot.patch
Patch0063: 0063-grub-core-mmap-i386-uppermem.c-lower_hook-COREBOOT-I.patch
Patch0064: 0064-grub-core-kern-i386-pc-mmap.c-Fallback-to-EISA-memor.patch
Patch0065: 0065-include-grub-i386-openbsd_bootarg.h-Add-addr-and-fre.patch
Patch0066: 0066-ieee1275-check-for-IBM-pseries-emulated-machine.patch
Patch0067: 0067-grub-core-loader-arm64-linux.c-Remove-redundant-0x.patch
Patch0068: 0068-grub-core-lib-relocator.c-Fix-the-case-when-end-of-l.patch
Patch0069: 0069-Fix-grub-probe-0-option.patch
Patch0070: 0070-Fix-partmap-cryptodisk-and-abstraction-handling-in-g.patch
Patch0071: 0071-btrfs-fix-get_root-key-comparison-failures-due-to-en.patch
Patch0072: 0072-grub-core-osdep-linux-getroot.c-grub_util_part_to_di.patch
Patch0073: 0073-Replace-few-instances-of-memcmp-memcpy-in-the-code-t.patch
Patch0074: 0074-include-grub-libgcc.h-Remove-ctzsi2-and-ctzdi2.-They.patch
Patch0075: 0075-Add-missing-endif.patch
Patch0076: 0076-grub-core-lib-syslinux_parse.c-Fix-timeout-quoting.patch
Patch0077: 0077-Improve-LVM-logical_volumes-string-matching.patch
Patch0078: 0078-Tolerate-devices-with-no-filesystem-UUID-returned-by.patch
Patch0079: 0079-Allow-loading-old-kernels-by-placing-GDT-in-conventi.patch
Patch0080: 0080-grub-core-kern-misc.c-__bzero-Don-t-compile-in-GRUB_.patch
Patch0081: 0081-grub-core-commands-verify.c-grub_pubkey_open-Fix-mem.patch
Patch0082: 0082-grub-core-commands-verify.c-grub_pubkey_open-Trust-p.patch
Patch0083: 0083-util-grub-gen-asciih.c-add_glyph-Fix-uninitialised-v.patch
Patch0084: 0084-grub-core-commands-efi-lsefisystab.c-grub_cmd_lsefis.patch
Patch0085: 0085-grub-core-loader-i386-bsd.c-grub_netbsd_boot-Pass-po.patch
Patch0086: 0086-util-grub-install.c-Fix-handling-of-disk-module.patch
Patch0087: 0087-grub-core-commands-loadenv.c-check_blocklists-Fix-ov.patch
Patch0088: 0088-NEWS-The-cmosclean-command-in-fact-dates-back-to-1.9.patch
Patch0089: 0089-Migrate-PPC-from-Yaboot-to-Grub2.patch
Patch0090: 0090-Add-fw_path-variable-revised.patch
Patch0091: 0091-Add-support-for-linuxefi.patch
Patch0092: 0092-Use-linuxefi-and-initrdefi-where-appropriate.patch
Patch0093: 0093-Don-t-allow-insmod-when-secure-boot-is-enabled.patch
Patch0094: 0094-Pass-x-hex-hex-straight-through-unmolested.patch
Patch0095: 0095-Fix-crash-on-http.patch
Patch0096: 0096-IBM-client-architecture-CAS-reboot-support.patch
Patch0097: 0097-Add-vlan-tag-support.patch
Patch0098: 0098-Add-X-option-to-printf-functions.patch
Patch0099: 0099-DHCP-client-ID-and-UUID-options-added.patch
Patch0100: 0100-Search-for-specific-config-file-for-netboot.patch
Patch0101: 0101-blscfg-add-blscfg-module-to-parse-Boot-Loader-Specif.patch
Patch0102: 0102-Move-bash-completion-script-922997.patch
Patch0103: 0103-for-ppc-reset-console-display-attr-when-clear-screen.patch
Patch0104: 0104-Don-t-write-messages-to-the-screen.patch
Patch0105: 0105-Don-t-print-GNU-GRUB-header.patch
Patch0106: 0106-Don-t-add-to-highlighted-row.patch
Patch0107: 0107-Message-string-cleanups.patch
Patch0108: 0108-Fix-border-spacing-now-that-we-aren-t-displaying-it.patch
Patch0109: 0109-Use-the-correct-indentation-for-the-term-help-text.patch
Patch0110: 0110-Indent-menu-entries.patch
Patch0111: 0111-Fix-margins.patch
Patch0112: 0112-Add-support-for-UEFI-operating-systems-returned-by-o.patch
Patch0113: 0113-Disable-GRUB-video-support-for-IBM-power-machines.patch
Patch0114: 0114-Use-2-instead-of-1-for-our-right-hand-margin-so-line.patch
Patch0115: 0115-Use-linux16-when-appropriate-880840.patch
Patch0116: 0116-Enable-pager-by-default.-985860.patch
Patch0117: 0117-F10-doesn-t-work-on-serial-so-don-t-tell-the-user-to.patch
Patch0118: 0118-Don-t-say-GNU-Linux-in-generated-menus.patch
Patch0119: 0119-Don-t-draw-a-border-around-the-menu.patch
Patch0120: 0120-Use-the-standard-margin-for-the-timeout-string.patch
Patch0121: 0121-Fix-grub_script_execute_sourcecode-usage-on-ppc.patch
Patch0122: 0122-Add-.eh_frame-to-list-of-relocations-stripped.patch
Patch0123: 0123-Make-10_linux-work-with-our-changes-for-linux16-and-.patch
Patch0124: 0124-Don-t-print-during-fdt-loading-method.patch
Patch0125: 0125-Honor-a-symlink-when-generating-configuration-by-gru.patch
Patch0126: 0126-Don-t-munge-raw-spaces-when-we-re-doing-our-cmdline-.patch
Patch0127: 0127-Don-t-require-a-password-to-boot-entries-generated-b.patch
Patch0128: 0128-Don-t-emit-Booting-.-message.patch
Patch0129: 0129-Make-CTRL-and-ALT-keys-work-as-expected-on-EFI-syste.patch
Patch0130: 0130-May-as-well-try-it.patch
Patch0131: 0131-use-fw_path-prefix-when-fallback-searching-for-grub-.patch
Patch0132: 0132-Try-mac-guid-etc-before-grub.cfg-on-tftp-config-file.patch
Patch0133: 0133-trim-arp-packets-with-abnormal-size.patch
Patch0134: 0134-Fix-convert-function-to-support-NVMe-devices.patch
Patch0135: 0135-Fix-bad-test-on-GRUB_DISABLE_SUBMENU.patch
Patch0136: 0136-Switch-to-use-APM-Mustang-device-tree-for-hardware-t.patch
Patch0137: 0137-Use-the-default-device-tree-from-the-grub-default-fi.patch
Patch0138: 0138-reopen-SNP-protocol-for-exclusive-use-by-grub.patch
Patch0139: 0139-Reduce-timer-event-frequency-by-10.patch
Patch0140: 0140-always-return-error-to-UEFI.patch

Patch10000: avoid_no_symbol_table.patch

BuildRequires:  flex bison binutils python
BuildRequires:  ncurses-devel xz-devel bzip2-devel

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  flex bison binutils python
BuildRequires:  ncurses-devel xz-devel
BuildRequires:  freetype-devel libusb-devel
%ifarch %{sparc} x86_64
BuildRequires:  glibc-devel glibc-static
%else
BuildRequires:  glibc-devel glibc-static
%endif
BuildRequires:  autoconf automake autogen device-mapper-devel
BuildRequires:  freetype-devel gettext-devel git
BuildRequires:  texinfo
BuildRequires:  fuse-devel

Requires:       gettext os-prober which
Requires(pre):  dracut
Requires(post): dracut
Requires(post): info
Requires(preun): info

# ExclusiveArch:  %{ix86} x86_64 %{sparc}

Obsoletes:      grub2 <= 2.00-3m

%description
The GRand Unified Bootloader (GRUB) is a highly configurable and customizable
bootloader with modular architecture.  It support rich varietyof kernel formats,
file systems, computer architectures and hardware devices.

%ifarch %{efi}
%package efi
Summary:        GRUB for EFI systems.
Group:          System Environment/Base
Requires:       grub2
Obsoletes:      grub-efi < 0.98

%description efi
The GRand Unified Bootloader (GRUB) is a highly configurable and customizable
bootloader with modular architecture.  It support rich varietyof kernel formats,
file systems, computer architectures and hardware devices.  This subpackage
provides support for EFI systems.

%package efi-modules
Summary:	Modules used to build custom grub.efi images
Group:		System Environment/Base
Requires:	%{name}-tools = %{version}-%{release}
Obsoletes:	grub2-efi <= 2.00-3m

%description efi-modules
The GRand Unified Bootloader (GRUB) is a highly configurable and customizable
bootloader with modular architecture.  It support rich varietyof kernel formats,
file systems, computer architectures and hardware devices.  This subpackage
provides support for rebuilding your own grub.efi on EFI systems.
%endif

%package tools
Summary:	Support tools for GRUB.
Group:		System Environment/Base
Requires:	gettext os-prober which file system-logos

%description tools
The GRand Unified Bootloader (GRUB) is a highly configurable and customizable
bootloader with modular architecture.  It support rich varietyof kernel formats,
file systems, computer architectures and hardware devices.  This subpackage
provides tools for support of all platforms.

%package starfield-theme
Summary:	An example theme for GRUB.
Group:		System Environment/Base
Requires:	system-logos
Obsoletes:	grub2 <= 2.00-3m
Obsoletes:	grub2-efi <= 2.00-3m

%description starfield-theme
The GRand Unified Bootloader (GRUB) is a highly configurable and customizable
bootloader with modular architecture.  It support rich varietyof kernel formats,
file systems, computer architectures and hardware devices.  This subpackage
provides an example theme for the grub screen.

%prep
#%%setup -T -c -n grub-%{version}
%setup -T -c -n grub-%{src_version}
%ifarch %{efi}

#%%setup -D -q -T -a 0 -n grub-%{version}
%setup -D -q -T -a 0 -n grub-%{src_version}
cd grub-%{src_version}
cp %{SOURCE3} .
# place unifont in the '.' from which configure is run
cp %{SOURCE4} unifont.pcf.gz

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1
%patch0041 -p1
%patch0042 -p1
%patch0043 -p1
%patch0044 -p1
%patch0045 -p1
%patch0046 -p1
%patch0047 -p1
%patch0048 -p1
%patch0049 -p1
%patch0050 -p1
%patch0051 -p1
%patch0052 -p1
%patch0053 -p1
%patch0054 -p1
%patch0055 -p1
%patch0056 -p1
%patch0057 -p1
%patch0058 -p1
%patch0059 -p1
%patch0060 -p1
%patch0061 -p1
%patch0062 -p1
%patch0063 -p1
%patch0064 -p1
%patch0065 -p1
%patch0066 -p1
%patch0067 -p1
%patch0068 -p1
%patch0069 -p1
%patch0070 -p1
%patch0071 -p1
%patch0072 -p1
%patch0073 -p1
%patch0074 -p1
%patch0075 -p1
%patch0076 -p1
%patch0077 -p1
%patch0078 -p1
%patch0079 -p1
%patch0080 -p1
%patch0081 -p1
%patch0082 -p1
%patch0083 -p1
%patch0084 -p1
%patch0085 -p1
%patch0086 -p1
%patch0087 -p1
%patch0088 -p1
%patch0089 -p1
%patch0090 -p1
%patch0091 -p1
%patch0092 -p1
%patch0093 -p1
%patch0094 -p1
%patch0095 -p1
%patch0096 -p1
%patch0097 -p1
%patch0098 -p1
%patch0099 -p1
%patch0100 -p1
%patch0101 -p1
%patch0102 -p1
%patch0103 -p1
%patch0104 -p1
%patch0105 -p1
%patch0106 -p1
%patch0107 -p1
%patch0108 -p1
%patch0109 -p1
%patch0110 -p1
%patch0111 -p1
%patch0112 -p1
%patch0113 -p1
%patch0114 -p1
%patch0115 -p1
%patch0116 -p1
%patch0117 -p1
%patch0118 -p1
%patch0119 -p1
%patch0120 -p1
%patch0121 -p1
%patch0122 -p1
%patch0123 -p1
%patch0124 -p1
%patch0125 -p1
%patch0126 -p1
%patch0127 -p1
%patch0128 -p1
%patch0129 -p1
%patch0130 -p1
%patch0131 -p1
%patch0132 -p1
%patch0133 -p1
%patch0134 -p1
%patch0135 -p1
%patch0136 -p1
%patch0137 -p1
%patch0138 -p1
%patch0139 -p1
%patch0140 -p1

%patch10000 -p1

cd ..
mv grub-%{src_version} grub-efi-%{src_version}
%endif
%setup -D -q -T -a 0 -n grub-%{src_version}

cd grub-%{src_version}
cp %{SOURCE3} .
# place unifont in the '.' from which configure is run
cp %{SOURCE4} unifont.pcf.gz
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1
%patch0041 -p1
%patch0042 -p1
%patch0043 -p1
%patch0044 -p1
%patch0045 -p1
%patch0046 -p1
%patch0047 -p1
%patch0048 -p1
%patch0049 -p1
%patch0050 -p1
%patch0051 -p1
%patch0052 -p1
%patch0053 -p1
%patch0054 -p1
%patch0055 -p1
%patch0056 -p1
%patch0057 -p1
%patch0058 -p1
%patch0059 -p1
%patch0060 -p1
%patch0061 -p1
%patch0062 -p1
%patch0063 -p1
%patch0064 -p1
%patch0065 -p1
%patch0066 -p1
%patch0067 -p1
%patch0068 -p1
%patch0069 -p1
%patch0070 -p1
%patch0071 -p1
%patch0072 -p1
%patch0073 -p1
%patch0074 -p1
%patch0075 -p1
%patch0076 -p1
%patch0077 -p1
%patch0078 -p1
%patch0079 -p1
%patch0080 -p1
%patch0081 -p1
%patch0082 -p1
%patch0083 -p1
%patch0084 -p1
%patch0085 -p1
%patch0086 -p1
%patch0087 -p1
%patch0088 -p1
%patch0089 -p1
%patch0090 -p1
%patch0091 -p1
%patch0092 -p1
%patch0093 -p1
%patch0094 -p1
%patch0095 -p1
%patch0096 -p1
%patch0097 -p1
%patch0098 -p1
%patch0099 -p1
%patch0100 -p1
%patch0101 -p1
%patch0102 -p1
%patch0103 -p1
%patch0104 -p1
%patch0105 -p1
%patch0106 -p1
%patch0107 -p1
%patch0108 -p1
%patch0109 -p1
%patch0110 -p1
%patch0111 -p1
%patch0112 -p1
%patch0113 -p1
%patch0114 -p1
%patch0115 -p1
%patch0116 -p1
%patch0117 -p1
%patch0118 -p1
%patch0119 -p1
%patch0120 -p1
%patch0121 -p1
%patch0122 -p1
%patch0123 -p1
%patch0124 -p1
%patch0125 -p1
%patch0126 -p1
%patch0127 -p1
%patch0128 -p1
%patch0129 -p1
%patch0130 -p1
%patch0131 -p1
%patch0132 -p1
%patch0133 -p1
%patch0134 -p1
%patch0135 -p1
%patch0136 -p1
%patch0137 -p1
%patch0138 -p1
%patch0139 -p1
%patch0140 -p1

%patch10000 -p1

%build

RPM_OPT_FLAGS="$RPM_OPT_FLAGS -Wno-unused-variable -Wno-error=cpp -Wno-unused-function -Wno-sign-compare -Wno-error"

%ifarch %{efi}
cd grub-efi-%{src_version}
./autogen.sh
%configure                                              	\
	CFLAGS="$(echo $RPM_OPT_FLAGS | sed			\
		-e 's/-O.//g'					\
		-e 's/-fstack-protector[[:alpha:]-]\? / /g'	\
		-e 's/--param=ssp-buffer-size=4//g'		\
		-e 's/-mregparm=3/-mregparm=4/g'		\
		-e 's/-fexceptions//g'				\
		-e 's/-fasynchronous-unwind-tables//g'		\
		-e 's/-m64//g' 						\
		-e 's/-fPIC//g'  					\
		-e 's/^/ -fno-strict-aliasing /' )"	 \
	TARGET_LDFLAGS=-static					\
        --with-platform=efi					\
	--with-grubdir=%{name}					\
        --program-transform-name=s,grub,%{name},		\
	--disable-grub-mount					\
	--disable--libzfs						\
	--disable-werror
make %{?_smp_mflags}
GRUB_MODULES="	all_video boot btrfs cat chain configfile echo efifwsetup \
		efinet ext2 fat font gfxmenu gfxterm gzio halt hfsplus iso9660 \
		jpeg lvm mdraid09 mdraid1x minicmd normal part_apple \
		part_msdos part_gpt password_pbkdf2 png reboot search \
		search_fs_uuid search_fs_file search_label sleep test tftp \
		video xfs mdraid09 mdraid1x"
%ifarch aarch64
GRUB_MODULES="${GRUB_MODULES} linux"
%else
GRUB_MODULES+="${GRUB_MODULES} linuxefi multiboot2 multiboot"
%endif
./grub-mkimage -O %{grubefiarch} -o %{grubefiname}.orig -p /EFI/%{efidir} \
		-d grub-core ${GRUB_MODULES}
%ifarch aarch64
mv %{grubefiname}.orig %{grubefiname}
%else
./grub-mkimage -O %{grubefiarch} -o %{grubeficdname}.orig -p /EFI/BOOT \
		-d grub-core ${GRUB_MODULES}
%pesign -s -i %{grubeficdname}.orig -o %{grubeficdname}
%pesign -s -i %{grubefiname}.orig -o %{grubefiname}
%endif
cd ..

cd grub-%{src_version}
./autogen.sh
# -static is needed so that autoconf script is able to link
# test that looks for _start symbol on 64 bit platforms
%ifarch %{sparc} ppc ppc64
%global platform ieee1275
%else
%global platform pc
%endif
%configure                                              	\
	CFLAGS="$(echo $RPM_OPT_FLAGS | sed			\
		-e 's/-O.//g'					\
		-e 's/-fstack-protector[[:alpha:]-]\? / /g'	\
		-e 's/--param=ssp-buffer-size=4//g'		\
		-e 's/-mregparm=3/-mregparm=4/g'		\
		-e 's/-fexceptions//g'				\
		-e 's/-m64//g' 					\
		-e 's/-fPIC//g' 					\
		-e 's/-fasynchronous-unwind-tables//g'		\
		-e 's/-mcpu=power7/-mcpu=power6/g'		\
		-e 's/^/ -fno-strict-aliasing /' )"		\
	TARGET_LDFLAGS=-static					\
        --with-platform=%{platform}				\
	--with-grubdir=%{name}					\
        --program-transform-name=s,grub,%{name},		\
	   --disable-grub-mount					\
	   --disable--libzfs						\
	   --disable-werror
make %{?_smp_mflags}

sed -i -e 's,(grub),(%{name}),g' \
        -e 's,grub.info,%{name}.info,g' \
        -e 's,\* GRUB:,* GRUB2:,g' \
        -e 's,/boot/grub/,/boot/%{name}/,g' \
        -e 's,grub-,%{name}-,g' \
        docs/grub.info
sed -i -e 's,grub-dev,%{name}-dev,g' docs/grub-dev.info

%install
set -e
rm -fr $RPM_BUILD_ROOT

%ifarch %{efi}
cd grub-efi-%{src_version}
make DESTDIR=$RPM_BUILD_ROOT install
find $RPM_BUILD_ROOT -iname "*.module" -exec chmod a-x {} \;

# Ghost config file
install -m 755 -d $RPM_BUILD_ROOT/boot/efi/EFI/%{efidir}/
touch $RPM_BUILD_ROOT/boot/efi/EFI/%{efidir}/grub.cfg
ln -s ../boot/efi/EFI/%{efidir}/grub.cfg $RPM_BUILD_ROOT%{_sysconfdir}/%{name}-efi.cfg

# Install ELF files modules and images were created from into
# the shadow root, where debuginfo generator will grab them from
find $RPM_BUILD_ROOT -name '*.mod' -o -name '*.img' |
while read MODULE
do
        BASE=$(echo $MODULE |sed -r "s,.*/([^/]*)\.(mod|img),\1,")
        # Symbols from .img files are in .exec files, while .mod
        # modules store symbols in .elf. This is just because we
        # have both boot.img and boot.mod ...
        EXT=$(echo $MODULE |grep -q '.mod' && echo '.elf' || echo '.exec')
        TGT=$(echo $MODULE |sed "s,$RPM_BUILD_ROOT,.debugroot,")
#        install -m 755 -D $BASE$EXT $TGT
done
install -m 755 %{grubefiname} $RPM_BUILD_ROOT/boot/efi/EFI/%{efidir}/%{grubefiname}
%ifnarch aarch64
install -m 755 %{grubeficdname} $RPM_BUILD_ROOT/boot/efi/EFI/%{efidir}/%{grubeficdname}
%endif
install -D -m 644 unicode.pf2 $RPM_BUILD_ROOT/boot/efi/EFI/%{efidir}/fonts/unicode.pf2
cd ..
%endif

cd grub-%{src_version}
make DESTDIR=$RPM_BUILD_ROOT install

# Ghost config file
install -d $RPM_BUILD_ROOT/boot/%{name}
touch $RPM_BUILD_ROOT/boot/%{name}/grub.cfg
ln -s ../boot/%{name}/grub.cfg $RPM_BUILD_ROOT%{_sysconfdir}/%{name}.cfg
%endif

cp -a $RPM_BUILD_ROOT%{_datarootdir}/locale/en\@quot $RPM_BUILD_ROOT%{_datarootdir}/locale/en

# Install ELF files modules and images were created from into
# the shadow root, where debuginfo generator will grab them from
find $RPM_BUILD_ROOT -name '*.mod' -o -name '*.img' |
while read MODULE
do
        BASE=$(echo $MODULE |sed -r "s,.*/([^/]*)\.(mod|img),\1,")
        # Symbols from .img files are in .exec files, while .mod
        # modules store symbols in .elf. This is just because we
        # have both boot.img and boot.mod ...
        EXT=$(echo $MODULE |grep -q '.mod' && echo '.elf' || echo '.exec')
        TGT=$(echo $MODULE |sed "s,$RPM_BUILD_ROOT,.debugroot,")
#        install -m 755 -D $BASE$EXT $TGT
done

mv $RPM_BUILD_ROOT%{_infodir}/grub.info $RPM_BUILD_ROOT%{_infodir}/%{name}.info
mv $RPM_BUILD_ROOT%{_infodir}/grub-dev.info $RPM_BUILD_ROOT%{_infodir}/%{name}-dev.info
rm $RPM_BUILD_ROOT%{_infodir}/dir

# Defaults
mkdir ${RPM_BUILD_ROOT}%{_sysconfdir}/default
touch ${RPM_BUILD_ROOT}%{_sysconfdir}/default/grub
mkdir ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
ln -sf %{_sysconfdir}/default/grub \
	${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/grub

cd ..
%find_lang grub

# Fedora theme in /boot/grub2/themes/system/
cd $RPM_BUILD_ROOT
tar xjf %{SOURCE5}
$RPM_BUILD_ROOT%{_bindir}/%{name}-mkfont -o boot/grub2/themes/system/DejaVuSans-10.pf2      -s 10 /usr/share/fonts/dejavu/DejaVuSans.ttf # "DejaVu Sans Regular 10"
$RPM_BUILD_ROOT%{_bindir}/%{name}-mkfont -o boot/grub2/themes/system/DejaVuSans-12.pf2      -s 12 /usr/share/fonts/dejavu/DejaVuSans.ttf # "DejaVu Sans Regular 12"
$RPM_BUILD_ROOT%{_bindir}/%{name}-mkfont -o boot/grub2/themes/system/DejaVuSans-Bold-14.pf2 -s 14 /usr/share/fonts/dejavu/DejaVuSans-Bold.ttf # "DejaVu Sans Bold 14"

# Make selinux happy with exec stack binaries.
mkdir ${RPM_BUILD_ROOT}%{_sysconfdir}/prelink.conf.d/
cat << EOF > ${RPM_BUILD_ROOT}%{_sysconfdir}/prelink.conf.d/grub2.conf
# these have execstack, and break under selinux
-b /usr/bin/grub2-script-check
-b /usr/bin/grub2-mkrelpath
-b /usr/bin/grub2-fstest
-b /usr/sbin/grub2-bios-setup
-b /usr/sbin/grub2-probe
-b /usr/sbin/grub2-sparc64-setup
EOF

%clean    
rm -rf $RPM_BUILD_ROOT

%post
if [ "$1" = 1 ]; then
  %{_sbindir}/install-info --info-dir=%{_infodir} %{_infodir}/grub-dev.info || :
  %{_sbindir}/install-info --info-dir=%{_infodir} %{_infodir}/%{name}.info || :
fi

%triggerun -- grub2 < 1.99-6m
# grub2 < 1.99-6m removed a number of essential files in postun. To fix upgrades
# from the affected grub2 packages, we first back up the files in triggerun and
# later restore them in triggerpostun.
# https://bugzilla.redhat.com/show_bug.cgi?id=735259

# Back up the files before uninstalling old grub2
mkdir -p /boot/grub2.tmp &&
mv -f /boot/grub2/*.mod \
      /boot/grub2/*.img \
      /boot/grub2/*.lst \
      /boot/grub2/device.map \
      /boot/grub2.tmp/ || :

%triggerpostun -- grub2 < 1.99-6m
# ... and restore the files.
test ! -f /boot/grub2/device.map &&
test -d /boot/grub2.tmp &&
mv -f /boot/grub2.tmp/*.mod \
      /boot/grub2.tmp/*.img \
      /boot/grub2.tmp/*.lst \
      /boot/grub2.tmp/device.map \
      /boot/grub2/ &&
rm -r /boot/grub2.tmp/ || :

%preun
if [ "$1" = 0 ]; then
  %{_sbindir}/install-info --delete --info-dir=%{_infodir} %{_infodir}/grub2.info || :
  %{_sbindir}/install-info --delete --info-dir=%{_infodir} %{_infodir}/grub2-dev.info || :
fi

%files 
%defattr(-,root,root,-)
%{_libdir}/grub/*-%{platform}/
%config(noreplace) %{_sysconfdir}/%{name}.cfg
%ghost %config(noreplace) /boot/%{name}/grub.cfg
%doc grub-%{src_version}/COPYING

%ifarch %{efi}
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}-efi.cfg
%attr(0755,root,root)/boot/efi/EFI/%{efidir}
%attr(0755,root,root)/boot/efi/EFI/%{efidir}/fonts
%ghost %config(noreplace) /boot/efi/EFI/%{efidir}/grub.cfg
%doc grub-%{src_version}/COPYING

%files efi-modules
%defattr(-,root,root,-)
%{_libdir}/grub/%{grubefiarch}
%endif

%files tools -f grub.lang
%defattr(-,root,root,-)
%dir %{_libdir}/grub/
%dir %{_datarootdir}/grub/
%dir %{_datarootdir}/grub/themes
%{_datarootdir}/grub/*
%{_sbindir}/%{name}-bios-setup
%{_sbindir}/%{name}-install
%{_sbindir}/%{name}-macbless
%{_sbindir}/%{name}-mkconfig
%{_sbindir}/%{name}-ofpathname
%{_sbindir}/%{name}-probe
%{_sbindir}/%{name}-reboot
%{_sbindir}/%{name}-set-default
%{_sbindir}/%{name}-sparc64-setup
%{_bindir}/%{name}-editenv
%{_bindir}/%{name}-file
%{_bindir}/%{name}-fstest
%{_bindir}/%{name}-glue-efi
%{_bindir}/%{name}-kbdcomp
%{_bindir}/%{name}-menulst2cfg
%{_bindir}/%{name}-mkfont
%{_bindir}/%{name}-mkimage
%{_bindir}/%{name}-mklayout
%{_bindir}/%{name}-mknetdir
%{_bindir}/%{name}-mkpasswd-pbkdf2
%{_bindir}/%{name}-mkrelpath
%ifnarch %{sparc}
%{_bindir}/%{name}-mkrescue
%endif
%{_bindir}/%{name}-mkstandalone
%{_bindir}/%{name}-render-label
%{_bindir}/%{name}-script-check
%{_bindir}/%{name}-syslinux2cfg
%{_datarootdir}/bash-completion/completions/grub
%{_sysconfdir}/prelink.conf.d/grub2.conf
%attr(0700,root,root) %dir %{_sysconfdir}/grub.d
%config %{_sysconfdir}/grub.d/??_*
%{_sysconfdir}/grub.d/README
%attr(0644,root,root) %ghost %config(noreplace) %{_sysconfdir}/default/grub
%{_sysconfdir}/sysconfig/grub
%dir /boot/%{name}
%dir /boot/%{name}/themes/
%dir /boot/%{name}/themes/system
%exclude /boot/%{name}/themes/system/*
%exclude %{_datarootdir}/grub/themes/
%{_infodir}/%{name}*
%exclude %{_mandir}
%doc grub-%{src_version}/COPYING grub-%{src_version}/INSTALL
%doc grub-%{src_version}/NEWS grub-%{src_version}/README
%doc grub-%{src_version}/THANKS grub-%{src_version}/TODO
#%%doc grub-%{src_version}/grub.html
#%%doc grub-%{src_version}/grub-dev.html grub-%{src_version}/docs/font_char_metrics.png
%doc grub-%{src_version}/themes/starfield/COPYING.CC-BY-SA-3.0

%files starfield-theme
%dir /boot/%{name}/themes/
%dir %{_datarootdir}/grub/themes
%dir %{_datarootdir}/grub/themes/starfield
/boot/%{name}/themes/
%{_datarootdir}/grub/themes/

%changelog
* Tue Oct 28 2014 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (2.02-0.4m)
- rebuild against zfs-0.6.3

* Tue Aug 05 2014 Yohsuke Ooi <meke@momonga-linux.org>
- (2.02-0.3m)
- disable zfs support. zfs.ko not default

* Fri Jul 11 2014 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.02-0.2m)
- fix Obsoletes

* Sun Jul 06 2014 Yohsuke Ooi <meke@momonga-linux.org>
- (2.02-0.1m)
- update 2.02-beta2

* Sun Sep 22 2013 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.00-3m)
- apply upstream patches

* Thu Feb 21 2013 NARITA Koichi <pulsar@momonga-linux.org>
- (2.00-2m)
- enable to build on i686

* Sun Feb 17 2013 NARITA Koichi <pulsar@momonga-linux.org>
- (2.00-1m)
- update 2.00

* Thu Jul 19 2012 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.00-0.94.4m)
- more fix up %%files

* Thu Jul 19 2012 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.00-0.94.3m)
- fix %%files to avoid conflicting

* Sun Apr 29 2012 Yohsuke Ooi <meke@momonga-linux.org> 
- (2.00-0.94.2m)
- add -Wno-error=cpp option
- import fedora patches

* Sat Apr 28 2012 Yohsuke Ooi <meke@momonga-linux.org> 
- (2.00-0.94.1m)
- update 2.00 beta4

* Mon Apr  2 2012 Yohsuke Ooi <meke@momonga-linux.org> 
- (2.00-0.93.1m)
- update 2.00 beta3

* Mon Mar 19 2012 Yohsuke Ooi <meke@momonga-linux.org> 
- (2.00-0.92.3m)
- remove -fPIC option
-- maybe fixed x86_64 error(2nd)

* Mon Mar 19 2012 Yohsuke Ooi <meke@momonga-linux.org> 
- (2.00-0.92.2m)
- fix CFLAGS option
- add -Wno-unused-variable
-- maybe fixed x86_64 error

* Mon Mar 19 2012 Yohsuke Ooi <meke@momonga-linux.org> 
- (2.00-0.92.1m)
- update 2.00-beta2

* Mon Jan 23 2012 Masahiro Takahata <takahata@momonga-linux.org>
- (1.99-6m)
- sync Fedora
- Don't do sysadminny things in %preun or %post ever. (rhbz#735259)

* Wed Jan 11 2012 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.99-5m)
- import fedora patches

* Fri Dec  2 2011 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.99-4m)
- import fedora patches

* Fri Oct 28 2011 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.99-3m)
- s/openSUSE/Momonga/

* Fri Sep  9 2011 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.99-2m)
- move grub.info to %%{name}.info to avoid conflicting with grub1
- add the handling of info files to %%post and %%preun

* Mon Aug 22 2011 Daniel McLellan <daniel.mclellan@gmail.com>
- (1.99-1m)
- update to 1.99 release, fix spec

* Wed May 11 2011 Daniel McLellan <daniel.mclellan@gmail.com>
- (1.98-1m)
- initial momonga release

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:1.98-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sat Jul 17 2010 Dennis Gilmore <dennis@ausil.us> - 1:1.98-3
- correctly generate a grub.cfg on kernel update

* Fri May 28 2010 Dennis Gilmore <dennis@ausil.us> - 1:1.98-2
- add patch so grub2-probe works with lvm to detect devices correctly

* Wed Apr 21 2010 Dennis Gilmore <dennis@ausil.us> - 1:1.98-1
- update to 1.98

* Fri Feb 12 2010 Dennis Gilmore <dennis@ausil.us> - 1:1.97.2-1
- update to 1.97.2

* Wed Jan 20 2010 Dennis Gilmore <dennis@ausil.us> - 1:1.97.1-5
- drop requires on mkinitrd

* Tue Dec 01 2009 Dennis Gilmore <dennis@ausil.us> - 1:1.97.1-4
- add patch so that grub2 finds fedora's initramfs

* Tue Nov 10 2009 Dennis Gilmore <dennis@ausil.us> - 1:1.97.1-3
- no mkrescue on sparc arches
- ofpathname on sparc arches
- Requires dracut, not sure if we should just drop mkinitrd for dracut

* Tue Nov 10 2009 Dennis Gilmore <dennis@ausil.us> - 1:1.97.1-2
- update filelists

* Tue Nov 10 2009 Dennis Gilmore <dennis@ausil.us> - 1:1.97.1-1
- update to 1.97.1 release
- introduce epoch for upgrades

* Tue Nov 10 2009 Dennis Gilmore <dennis@ausil.us> - 1.98-0.7.20090911svn
- fix BR

* Fri Sep 11 2009 Dennis Gilmore <dennis@ausil.us> - 1.98-0.6.20090911svn
- update to new svn snapshot
- add sparc support

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.98-0.6.20080827svn
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sun Mar 01 2009 Lubomir Rintel <lkundrak@v3.sk> - 1.98-0.4.20080827svn
- Add missing BR

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.98-0.4.20080827svn
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Aug 27 2008 Lubomir Rintel <lkundrak@v3.sk> - 1.98-0.3.20080827svn
- Updated SVN snapshot
- Added huge fat warnings

* Fri Aug 08 2008 Lubomir Rintel <lkundrak@v3.sk> - 1.98-0.2.20080807svn
- Correct scriptlet dependencies, trigger on kernel-PAE (thanks to Till Maas)
- Fix build on x86_64 (thanks to Marek Mahut)

* Thu Aug 07 2008 Lubomir Rintel <lkundrak@v3.sk> 1.98-0.1.20080807svn
- Another snapshot
- And much more!

* Mon May 12 2008 Lubomir Kundrak <lkundrak@redhat.com> 1.97-0.1.20080512cvs
- CVS snapshot
- buildid patch upstreamed

* Sat Apr 12 2008 Lubomir Kundrak <lkundrak@redhat.com> 1.96-2
- Pull in 32 bit glibc
- Fix builds on 64 bit

* Sun Mar 16 2008 Lubomir Kundrak <lkundrak@redhat.com> 1.96-1
- New upstream release
- More transformation fixes
- Generate -debuginfo from modules again. This time for real.
- grubby stub
- Make it possible to do configuration changes directly in grub.cfg
- grub.cfg symlink in /etc

* Thu Feb 14 2008 Lubomir Kundrak <lkundrak@redhat.com> 1.95.cvs20080214-3
- Update to latest trunk
- Manual pages
- Add pci.c to DISTLIST

* Mon Nov 26 2007 Lubomir Kundrak <lkundrak@redhat.com> 1.95.cvs20071119-2
- Fix program name transformation in utils
- Moved the modules to /lib
- Generate -debuginfo from modules again

* Sun Nov 18 2007 Lubomir Kundrak <lkundrak@redhat.com> 1.95.cvs20071119-1
- Synchronized with CVS, major specfile cleanup

* Mon Jan 30 2007 Lubomir Kundrak <lkundrak@skosi.org> 1.95-lkundrak1
- Removed redundant filelist entries

* Mon Jan 29 2007 Lubomir Kundrak <lkundrak@skosi.org> 1.95-lkundrak0
- Program name transformation
- Bump to 1.95
- grub-probefs -> grub-probe
- Add modules to -debuginfo

* Tue Sep 12 2006 Lubomir Kundrak <lkundrak@skosi.org> 1.94-lkundrak0
- built the package

